package edu.sc.seis.cormorant.seismogram;

import java.util.GregorianCalendar;
import java.util.TimeZone;

import edu.iris.Fissures.model.MicroSecondDate;
import edu.sc.seis.fissuresUtil.chooser.ClockUtil;

public class IrisDirListing {
    
    public IrisDirListing(String csv) {
        String[] items = csv.split(",");
        year = Integer.parseInt(items[0]);
        month = items[1];
        day = Integer.parseInt(items[2]);
        time = items[3];
        perm = items[4];
        size = Integer.parseInt(items[5]);
        filename = items[5];
    }

    public IrisDirListing(String[] items) {
        perm = items[0];
        size = Integer.parseInt(items[4]);
        month = items[5];
        day = Integer.parseInt(items[6]);
        try {
            year = Integer.parseInt(items[7]);
        } catch(NumberFormatException e) {
            // means recent file, time instead of date
            GregorianCalendar cal = new GregorianCalendar(TimeZone.getTimeZone("GMT"));
            cal.setTime(ClockUtil.now());
            year = cal.get(GregorianCalendar.YEAR);
            time = items[7];
        }
        filename = items[8];
    }

    String perm;

    int year, day;

    String month;

    String time = "00:00";

    String filename;

    int size;

    public String toCSV() {
        return year+","+month+","+day+","+time+","+perm+","+size+","+filename;
    }

    public MicroSecondDate getModTime() {
        try {
            return new MicroSecondDate(year+BudLightWriter.twoDigit.format(getMonthInt(month))+BudLightWriter.twoDigit.format(day)+"T"+time+":00Z");
        } catch (RuntimeException t) {
            logger.error(toCSV(), t);
            throw t;
        }
    }

    public static int getMonthInt(String month) {
        for (int i = 0; i < monthToInt.length; i++) {
            if (monthToInt[i].equalsIgnoreCase(month)) {
                return i+1;
            }
        }
        throw new RuntimeException("Can't find month number for '"+month+"'");
    }
    
    public static final String[] monthToInt = new String[] {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
    
    private static final org.slf4j.Logger logger = org.slf4j.LoggerFactory.getLogger(IrisDirListing.class);
}
